const inquirer = require('inquirer')
const _ = require('lodash')
const chalk = require('chalk')

const showResult = (result) => {
  console.log(result.summary)
  result.conditionReports.map((condition) => {
    console.log(`${condition.seriousnessAdvice}: ${condition.name}`)
  })
  process.exit()
}

const ask = (answerObj) => {
  const ada = require('../lib/index')
  ada('cli', answerObj, false, (err, question) => {
    if (err) return console.log(chalk.red.bold(err))
    if (question.summary) return showResult(question)
    if (question.isOver) return console.log(question.gibberish.join(' '))
    const iq = {
      type: question.answerType === 'SELECT' ? 'list' : 'input',
      message: question.question || 'An error occurred :(',
      name: 'key',
      validate: (input) => !!input.length
    }

    if (question.answerType === 'SELECT') {
      iq.choices = question.answerOptions.map((option) => option.text || option.patientName)
    }

    inquirer.prompt(iq, (answer) => {
      if (question.answerType === 'TEXT') return ask(answer.key)

      const answerObj = _.find(question.answerOptions, ['text', answer.key]) ||
       _.find(question.answerOptions, ['patientName', answer.key])
      ask(answerObj)
    })
  })
}

module.exports = ask
