'use strict'

const config = require('./rc')().get()

const api = require('./api.js')(config.medx.username, config.medx.password)
const store = require('./store.js')

module.exports = (key, answer, delteAllProfiles, handleResponse) => {
  const handleData = (err, data) => {
    if (err) return handleResponse(err)
    store.setState(key, data, (err) => {
      if (err) return handleResponse(err)
      handleResponse(null, data)
    })
  }

  if (!api.isLoggedIn()) return api.login(delteAllProfiles, handleData)

  store.getState(key, (err, state) => {
    if (err) throw err
    api.ask(answer, state, key === 'cli', handleData)
  })
}
